<?php

/**
 * IndexController - The default controller class
 * 
 * @author
 * @version 
 */

require_once 'Zend/Controller/Action.php';

class WizardController extends Zend_Controller_Action 
{
	/**
	 * The default action - show the home page
	 */
    public function indexAction() 
    {
        $this->initView(); 
        $this->view->baseUrl = $this->_request->getBaseUrl(); 
        $this->view->user = Zend_Auth::getInstance()->getIdentity(); 
		$model = $this->_getModel();
		$modelMail = $this->_getMailModel();
		
		$this->view->entries = $model->getWasteByUser($this->view->user->id);
		
		if ($this->getRequest()->isPost()) {
			$data=$this->getRequest()->getPost();
			$userdata=$model->fetchEntry($this->view->user->id);
			$msg=chr(13).chr(10);
			foreach($this->view->entries as $item){
				$msg.=$item["descrizione"]." : ".$data['waste'.$item['id']].chr(13).chr(10);
			}
			$modelMail->sendMail($userdata["email"],"Nuovo carico. Utente: ".$userdata["denominazione"],"L'utente ".$userdata["denominazione"]." in data ".date("d-M-Y")." ha inserito un nuovo carico: ".$msg);
			$this->_redirect('/wizard'); 
		}
    }
	
	function preDispatch() 
    { 
        $auth = Zend_Auth::getInstance(); 
        if (!$auth->hasIdentity()) { 
            $this->_redirect('auth/private'); 
        } 
    }
	
	protected function _getModel()
    {
        if (null === $this->_model) {
            require_once APPLICATION_PATH . '/models/Users.php';
            $this->_model = new Model_Users();
        }
        return $this->_model;
    }
	
	protected function _getMailModel()
    {
        if (null === $this->_modelMail) {
            require_once APPLICATION_PATH . '/models/Mail.php';
            $this->_modelMail = new Model_Mail();
        }
        return $this->_modelMail;
    }
	
}
?>