<?php
require_once APPLICATION_PATH . '/models/Users.php';

class Form_Users extends Zend_Form
{

	protected $_rolesSelect;
	protected $_wasteSelect;
	public $_username;
	
	private $buttonDateDecorators = array(
		'ViewHelper',
		array(array('data' => 'HtmlTag'), array('tag' => 'span', 'class' => 'buttondate'))
	);
	
	private $dateDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'span')),
	);
	
	private $textDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'field')),
	);
	
	private $selectDecorators = array(
		array('Errors'),
		array(array('ErrorsDiv' => 'HtmlTag'), array('tag' => 'div', 'class' => 'notice_error')),
		array('ViewHelper'),
		array('Description', array('tag' => 'div', 'class' => 'description')),
		array('Label', array('tag' => 'span')),
		array('HtmlTag', array('tag' => 'div', 'class' => 'multiple')),
	);
    
	public function init()
    {
        
        $this->setMethod('post');

        $this->addElement('text', 'denominazione', array(
            'label'      => 'Denominazione:',
            'required'   => true,
			'size'   => 50,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 255))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('text', 'data_attivazione', array(
            'label'      => 'Data di attivazione:',
			'id'      => 'data_attivazione',
			'size'   => 10,
			'readonly'      => true,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 10))
            ),
			'decorators' => $this->dateDecorators,
        ));
		
		$this->addElement('button', 'calendar', array(
            'label'      => 'Scegli la data',
			'onClick' => 'makeCalendar(document.getElementById(\'data_attivazione\'));',
			'decorators' => $this->buttonDateDecorators,

        ));
		
		$this->addElement('text', 'giorni_attivazione', array(
            'label'      => 'Numero giorni di attivazione:',
            'required'   => true,
			'size'   => 5,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'Digits'),
				 array('validator' => 'StringLength', 'options' => array(0, 5))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('textarea', 'sede_legale', array(
            'label'      => 'Sede legale:',
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 255))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('textarea', 'ubicazione_esercizio', array(
            'label'      => 'Ubicazione esercizio:',
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 255))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('text', 'codice_fiscale', array(
            'label'      => 'Codice fiscale:',
			'size'   => 16,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('text', 'email', array(
            'label'      => 'Email:',
			'size'   => 16,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 100))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('text', 'num_iscrizione_albo', array(
            'label'      => 'Iscrizione Albo n.:',
			'size'   => 40,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 255))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->_username = new Zend_Form_Element_Text('username', array(
            'label'      => 'Username:',
			'size'   => 10,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement($this->_username);
		
		$this->addElement('text', 'password', array(
            'label'      => 'Password:',
			'size'   => 10,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'StringLength', 'options' => array(0, 20))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$this->addElement('text', 'progressivo', array(
            'label'      => 'Progressivo:',
			'size'   => 5,
            'required'   => true,
            'filters'    => array('StringTrim'),
            'validators' => array(
                 array('validator' => 'Digits'),
				 array('validator' => 'StringLength', 'options' => array(0, 5))
            ),
			'decorators' => $this->textDecorators
        ));
		
		$user = Zend_Auth::getInstance()->getIdentity();
		$table=new Model_Users();
		$rsArray = $table->getRolesByUser($user->id);
		$role=$table->getActiveRoles($rsArray); 
		
		
		$this->_rolesSelect = new Zend_Form_Element_Multiselect('ruoli');
		$this->_rolesSelect->setLabel('Ruoli:');
		$this->_rolesSelect->setDecorators($this->selectDecorators);
		$table=new Roles();
		$rows=$table->fetchAll()->toArray();
		if(!empty($rows)){
			foreach($rows as $ruolo){
			  $this->_rolesSelect->addMultiOption($ruolo['id'], $ruolo['descrizione']);
			}
		}
		if($role['AMM'])
			$this->addElement($this->_rolesSelect);
		
		
		$this->_wasteSelect = new Zend_Form_Element_Multiselect('rifiuti');
		$this->_wasteSelect->setLabel('Rifiuti:');
		$this->_wasteSelect->setDecorators($this->selectDecorators);
		$table=new UWaste();
		$rows=$table->fetchAll()->toArray();
		if(!empty($rows)){
			foreach($rows as $item){
			  $this->_wasteSelect->addMultiOption($item['id'], $item['descrizione']);
			}
		}

		$this->addElement($this->_wasteSelect);

        $this->addElement('submit', 'submit', array(
            'label'    => 'Conferma'
        ));
    }
	
	public function setRoles($data)
	{
		$this->_rolesSelect->setValue($data);
	}
	
	public function setWaste($data)
	{
		$this->_wasteSelect->setValue($data);
	} 
}
?>