<?php
require_once APPLICATION_PATH . '/models/DbTable/Loading.php';

class Model_Loading {
    protected $_table;
    
 
	public function fetchEntries($orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		$select = $table->select()->order($orderby.' '.$orderdir);
        return $table->fetchAll($select)->toArray();
    }
	
	public function getItemsByWasteAndDate($wasteid,$fromdate,$todate)
    {
		$table=new Loading();
		
		
		$selectC = $table->select()->setIntegrityCheck(false);
		$selectC = $selectC->from('carichi',array('concat(\'c\',carichi.id) as id','carichi.progressivo','carichi.data'))
				  ->where('carichi.id_rifiuto = ?', $wasteid)
				  ->where('carichi.data >= ?', $fromdate)->where('carichi.data <= ?',$todate);
				  
		$selectS = $table->select()->setIntegrityCheck(false);
		$selectS = $selectS->from('scarichi',array('concat(\'s\',scarichi.id) as id','scarichi.progressivo','scarichi.data'))
				 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id','')
				 ->join('carichi','scarico_carichi.id_carico=carichi.id','')
				 ->where('carichi.id_rifiuto = ?', $wasteid)
				 ->where('scarichi.data >= ?', $fromdate)->where('scarichi.data <= ?',$todate);
		 
        return Zend_Registry::get('dbAdapter')->fetchAll($selectS." UNION ".$selectC." ORDER BY data,progressivo ASC");
    }
	
	public function getItemsByUserAndWasteAndDate($userid,$wasteid,$fromdate,$todate)
    {
		$table=new Loading();
		
		
		$selectC = $table->select()->setIntegrityCheck(false);
		$selectC = $selectC->from('carichi',array('concat(\'c\',carichi.id) as id','carichi.progressivo'))
				  ->where('carichi.id_rifiuto = ?', $wasteid)
				  ->where('carichi.data >= ?', $fromdate)->where('carichi.data <= ?',$todate)
				  ->where('carichi.id_utente = ?', $userid);
				  
		$selectS = $table->select()->setIntegrityCheck(false);
		$selectS = $selectS->from('scarichi',array('concat(\'s\',scarichi.id) as id','scarichi.progressivo'))
				 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id','')
				 ->join('carichi','scarico_carichi.id_carico=carichi.id','')
				 ->where('carichi.id_rifiuto = ?', $wasteid)
				 ->where('scarichi.data >= ?', $fromdate)->where('scarichi.data <= ?',$todate)
				 ->where('carichi.id_utente = ?', $userid);
		 
        return Zend_Registry::get('dbAdapter')->fetchAll($selectS." UNION ".$selectC." ORDER BY progressivo ASC");
    }
	
	public function getItemsByUser($userid)
    {
		$table=new Loading();
		
		
		$selectC = $table->select()->setIntegrityCheck(false);
		$selectC = $selectC->from('carichi',array('concat(\'c\',carichi.id) as id','carichi.progressivo'))
				  ->where('carichi.id_utente = ?', $userid);
				  
		$selectS = $table->select()->setIntegrityCheck(false);
		$selectS = $selectS->from('scarichi',array('concat(\'s\',scarichi.id) as id','scarichi.progressivo'))
				 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id','')
				 ->join('carichi','scarico_carichi.id_carico=carichi.id','')
				  ->where('carichi.id_utente = ?', $userid);
		 
        return Zend_Registry::get('dbAdapter')->fetchAll($selectS." UNION ".$selectC." ORDER BY progressivo ASC");
    }
	
	public function getNotPrintedItemsByUser($userid)
    {
		$table=new Loading();
		
		
		$selectC = $table->select()->setIntegrityCheck(false);
		$selectC = $selectC->from('carichi',array('concat(\'c\',carichi.id) as id','carichi.progressivo'))
				  ->where('carichi.id_utente = ?', $userid)
				  ->where('carichi.stampato = 0');
				  
		$selectS = $table->select()->setIntegrityCheck(false);
		$selectS = $selectS->from('scarichi',array('concat(\'s\',scarichi.id) as id','scarichi.progressivo'))
				 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id','')
				 ->join('carichi','scarico_carichi.id_carico=carichi.id','')
				  ->where('carichi.id_utente = ?', $userid)
				  ->where('scarichi.stampato = 0');
		 
        return Zend_Registry::get('dbAdapter')->fetchAll($selectS." UNION ".$selectC." ORDER BY progressivo ASC");
    }
	
	public function getNotPrintedItemsByUserAndDate($userid,$fromdate,$todate)
    {
		$table=new Loading();
		
		
		$selectC = $table->select()->setIntegrityCheck(false);
		$selectC = $selectC->from('carichi',array('concat(\'c\',carichi.id) as id','carichi.progressivo'))
				  ->where('carichi.id_utente = ?', $userid)->where('carichi.data >= ?', $fromdate)->where('carichi.data <= ?',$todate);
				  
		$selectS = $table->select()->setIntegrityCheck(false);
		$selectS = $selectS->from('scarichi',array('concat(\'s\',scarichi.id) as id','scarichi.progressivo'))
				 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id','')
				 ->join('carichi','scarico_carichi.id_carico=carichi.id','')
				  ->where('carichi.id_utente = ?', $userid)->where('scarichi.data >= ?', $fromdate)->where('scarichi.data <= ?',$todate);
		 
        return Zend_Registry::get('dbAdapter')->fetchAll($selectS." UNION ".$selectC." ORDER BY progressivo ASC");
    }
	
	public function getUnloadNotPrintedByUser($userid)
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id')
						 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->where('carichi.id_utente = ?',$userid)
						 ->where('carichi.stampato = 0')
						 ->group('scarichi.id')
						 ->order('progressivo ASC');
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoadingByUser($userid,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
						 ->where('carichi.id_utente = ?', $userid)
						 ->order($orderby.' '.$orderdir);
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadingByUser($userid,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id')
						 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->where('carichi.id_utente = ?',$userid)
						 ->group('scarichi.id')
						 ->order($orderby.' '.$orderdir);
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadingByFormulario($formulario,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->where('LOWER(scarichi.formulario_num) = ?',strtolower($formulario))
						 ->group('scarichi.id')
						 ->order($orderby.' '.$orderdir);
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoadingByUserAndNote($userid,$text,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
						 ->where('carichi.id_utente = ?', $userid)->where('carichi.note LIKE ?', '%'.$text.'%')
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadingByUserAndNote($userid,$text,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id')
						 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->where('carichi.id_utente = ?', $userid)->where('scarichi.note LIKE ?', '%'.$text.'%')
						 ->group('scarichi.id')
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoadingByUserAndWaste($userid,$wasteid,$unloaded,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		if($wasteid!=-1){
			if($unloaded==1)
				$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
								 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
								 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
								 ->join('scarico_carichi','scarico_carichi.id_carico=carichi.id',array('scarico_carichi.id_scarico'))
								 ->where('carichi.id_utente = ?', $userid)->where('rifiuti.id = ?', $wasteid)
								 ->group('carichi.id')
								 ->order($orderby.' '.$orderdir);
			else
				$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
								 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
								 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
								 ->where('carichi.id NOT IN (SELECT id_carico FROM scarico_carichi)')
								 ->where('carichi.id_utente = ?', $userid)->where('rifiuti.id = ?', $wasteid)
								 ->group('carichi.id')
								 ->order($orderby.' '.$orderdir);
		}else{
			if($unloaded==1)
				$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
								 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
								 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
								 ->join('scarico_carichi','scarico_carichi.id_carico=carichi.id',array('scarico_carichi.id_scarico'))
								 ->where('carichi.id_utente = ?', $userid)
								 ->group('carichi.id')
								 ->order($orderby.' '.$orderdir);
			else
				$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
								 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
								 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
								 ->where('carichi.id_utente = ?', $userid)
								 ->where('carichi.id NOT IN (SELECT id_carico FROM scarico_carichi)')
								 ->group('carichi.id')
								 ->order($orderby.' '.$orderdir);
		}
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadingByUserAndWaste($userid,$wasteid,$unloaded,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		if($wasteid!=-1){
				$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
								 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
								 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
								 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
								 ->where('carichi.id_utente = ?', $userid)->where('rifiuti.id = ?', $wasteid)
								 ->group('scarichi.id')
								 ->order($orderby.' '.$orderdir);
		}else{
				$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
								 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
								 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
								 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
								 ->where('carichi.id_utente = ?', $userid)
								 ->group('scarichi.id')
								 ->order($orderby.' '.$orderdir);
		}
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoadingByUserAndDate($userid,$fromdate,$todate,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
						 ->where('carichi.id_utente = ?', $userid)->where('carichi.data >= ?', $fromdate)->where('carichi.data <= ?',$todate)
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoadingByUserAndDateAndWaste($userid,$wasteid,$fromdate,$todate,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
						 ->where('carichi.id_utente = ?', $userid)->where('carichi.data >= ?', $fromdate)->where('carichi.data <= ?',$todate)->where('carichi.id_rifiuto = ?', $wasteid)
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadingByUserAndDate($userid,$fromdate,$todate,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
						 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
					  	 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->where('carichi.id_utente = ?', $userid)->where('scarichi.data >= ?', $fromdate)->where('scarichi.data <= ?',$todate)
						 ->group('scarichi.id')
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadingByUserAndFormulario($userid,$code,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id')
						 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->where('carichi.id_utente = ?', $userid)->where('scarichi.formulario_num LIKE ?', '%'.$code.'%')
						 ->group('scarichi.id')
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoading($loadid,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico','carichi.cod_smaltimento as cod_smaltimento_c','carichi.cod_recupero as cod_recupero_c'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
						 ->where('carichi.id = ?', $loadid)
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloading($unloadid,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('scarichi',array('scarichi.*','scarichi.id as id_scarico'))
						 ->join('scarico_carichi','scarico_carichi.id_scarico=scarichi.id')
						 ->join('carichi','scarico_carichi.id_carico=carichi.id',array('carichi.id_rifiuto','carichi.id_utente'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=scarichi.id_um_qtd')
						 ->where('scarichi.id = ?', $unloadid)
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getLoadByUnloading($unloadid,$orderby="data",$orderdir="desc")
    {
		$table=new Loading();
		
		
		$select = $table->select()->setIntegrityCheck(false);
		$select = $select->from('carichi',array('carichi.*','carichi.id as id_carico','carichi.cod_smaltimento as cod_smaltimento_c','carichi.cod_recupero as cod_recupero_c'))
						 ->join('rifiuti','rifiuti.id=carichi.id_rifiuto',array('rifiuti.*'))
						 ->join('unita_di_misura','unita_di_misura.id=carichi.id_unita_di_misura')
						 ->join('scarico_carichi','scarico_carichi.id_carico=carichi.id')
						 ->where('scarico_carichi.id_scarico = ?', $unloadid)
						 ->order($orderby.' '.$orderdir);
		
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUnloadByLoading($loadid)
    {
		$table=new UnloadLoading();
		$select = $table->select()->where('id_carico = ?', $loadid);
        return $table->fetchAll($select)->toArray();
    }
	
	public function getUdm($id)
    {
        $table = new UdM();
        $select = $table->select()->where('id = ?', $id);
		$select=$table->fetchRow($select);
		if($select)
        	return $select->toArray();
		else
			return null;
    }
	
	public function fetchEntry($id)
    {
        $table = new Loading();
        $select = $table->select()->where('id = ?', $id);
		$select=$table->fetchRow($select);
		if($select)
        	return $select->toArray();
		else
			return null;
    }
	
	public function fetchEntryUnload($id)
    {
        $table = new Unloading();
        $select = $table->select()->where('id = ?', $id);
		$select=$table->fetchRow($select);
		if($select)
        	return $select->toArray();
		else
			return null;
    }
	
	public function save(array $data)
    {
		$table=new Loading();
        $fields = $table->info(Zend_Db_Table_Abstract::COLS);
        foreach ($data as $field => $value) {
            if (!in_array($field, $fields)) {
                unset($data[$field]);
            }
        }
		
		$table->insert($data);
		
        return $table->getAdapter()->lastInsertId();
    }
	
	public function saveLoads($loadid,array $data)
    {
        $table=new UnloadLoading();
        $loads=array();
		foreach($data as $load){
			$loads['id_scarico']=$loadid;
			$loads['id_carico']=$load['id'];
			$table->insert($loads);
		}
		
        return $table->getAdapter()->lastInsertId();
    }
	
	public function saveUnload(array $data)
    {
		$table=new Unloading();
        $fields = $table->info(Zend_Db_Table_Abstract::COLS);
        foreach ($data as $field => $value) {
            if (!in_array($field, $fields)) {
                unset($data[$field]);
            }
        }
		
		$table->insert($data);
		
        return $table->getAdapter()->lastInsertId();
    }
	
	public function modify(array $data,$loadingid)
    {
        $table=new Loading();
        $fields = $table->info(Zend_Db_Table_Abstract::COLS);
        foreach ($data as $field => $value) {
            if (!in_array($field, $fields)) {
                unset($data[$field]);
            }
        }
		
		$where=$table->getAdapter()->quoteInto('id = ?', $loadingid);
		return $table->update($data,$where);
    }
	
	public function modifyUnload(array $data,$loadingid)
    {
        $table=new Unloading();
        $fields = $table->info(Zend_Db_Table_Abstract::COLS);
        foreach ($data as $field => $value) {
            if (!in_array($field, $fields)) {
                unset($data[$field]);
            }
        }
		
		$where=$table->getAdapter()->quoteInto('id = ?', $loadingid);
		return $table->update($data,$where);
    }
	
	public function deleteunload($loadingid)
    {
        $table=new Unloading();
		$where=$table->getAdapter()->quoteInto('id = ?', $loadingid);
		return $table->delete($where);
    }
	
	public function deleteLoadByUnload($loadingid,$unloadingid)
    {
        $table=new UnloadLoading();
		$select=$table->getAdapter()->quoteInto('id_carico = ?', $loadingid). ' AND ' .$table->getAdapter()->quoteInto('id_scarico = ?', $unloadingid);
		return $table->delete($select);
    }
	
	public function delete($loadingid)
    {
        $table=new Loading();
		$where=$table->getAdapter()->quoteInto('id = ?', $loadingid);
		return $table->delete($where);
    }
	
	
}

?>